// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

#include "fragmentVersionCentroid.h"

#if __VERSION__ >= 300
	#ifndef BYPASS_PIXEL_SHADER
		#if defined(TEXEL_AA) && defined(TEXEL_AA_FEATURE)
			_centroid in highp vec2 uv0;
			_centroid in highp vec2 uv1;
		#else
			_centroid in vec2 uv0;
			_centroid in vec2 uv1;
		#endif
	#endif
#else
	#ifndef BYPASS_PIXEL_SHADER
		varying vec2 uv0;
		varying vec2 uv1;
	#endif
#endif

varying vec4 color;
varying highp vec3 p;
varying highp vec3 wpos;
varying vec3 position;

#ifdef FOG
varying vec4 fogColor;
#endif

#include "uniformShaderConstants.h"
#include "uniformPerFrameConstants.h"
#include "util.h"
#include "lib/noise.h"
#include "lib/fragment_define.h"

/*=========
JBRX v1.0 (last)

My first shader 
And lastly from the JBRX shader

Redezerd Graph
Shaders by Ilyas M

Twitter: @RDZG12
===========*/

//Please don't steal any code
//Please don't change the name

vec3 ACESFilm( vec3 x ) {
	float a = 3.4f;
	float b = 0.001f;
	float c = 1.8f;
	float d = 0.59f;
	float e = 0.4f;
return((x*(a*x+b))/(x*( c * x + d ) + e ) );}

LAYOUT_BINDING(0) uniform sampler2D TEXTURE_0;
LAYOUT_BINDING(1) uniform sampler2D TEXTURE_1;
LAYOUT_BINDING(2) uniform sampler2D TEXTURE_2;

highp float wave(highp vec2 p){
float wave = pow(0.3,noise(vec2(
	TIME*1.7+p.x+p.x*.001,
	TIME*3.0+p.y+p.x+p.x*1.0+p.y*3.0)))+
	sin(noise(vec2(
	TIME*1.0+p.x+p.x+p.y+p.x*.001,
	TIME*0.8+p.y+p.x+p.x*0.7+p.y*2.0)));
return wave;
}

void main()
{
#ifdef BYPASS_PIXEL_SHADER
	gl_FragColor = vec4(0, 0, 0, 0);
	return;
#else 

#if USE_TEXEL_AA
	vec4 RDZres = texture2D_AA(TEXTURE_0, uv0);
#else
	vec4 RDZres = texture2D(TEXTURE_0, uv0);
#endif
	
#ifdef SEASONS_FAR
	RDZres.a = 1.0;
#endif

float time = texture2D(TEXTURE_1, vec2(0., 1.)).r;

time = max(0.0, min( 1.0,(time-0.5)*2.0));

//TIME
float siangd = time;
float malamd = 1.-siangd*uv1.y;
float sorepagid = 0.5-abs(0.5-siangd);
float hujand = smoothstep(.66, .3, FOG_CONTROL.x)*uv1.y;
float goa = smoothstep(.5,.0, uv1.y);

highp vec3 dirlek = normalize(cross(dFdx(p.xyz),dFdy(p.xyz)));
highp float fresnel = dot(normalize(wpos), vec3(0., 1., 0.));
highp vec3 blockpos = fract(p.xyz);
highp vec4 Light = texture2D(TEXTURE_1, uv1);

highp vec4 bscshdG = vec4(0.81,0.83,0.85,-0.1)*0.8;
bscshdG = mix(vec4(1.), bscshdG, 1.-uv1.x);
highp vec4 bscshdG2 = vec4(0.81,0.83,0.85,-0.1)*0.6;

#if USE_ALPHA_TEST
	#ifdef ALPHA_TO_COVERAGE
	#define ALPHA_THRESHOLD 0.05
	#else
	#define ALPHA_THRESHOLD 0.5
	#endif
	if(RDZres.a < ALPHA_THRESHOLD)
		discard;
#endif
	
vec4 inColor = color;

#if defined(BLEND)
	RDZres.a *= inColor.a;
#endif

	vec3 night = vec3(0.13,0.13,0.14);

Light.rgb *= pow(Light.rgb, 1.0-night);

#if !defined(ALWAYS_LIT)
	RDZres *= Light;
#endif

#ifndef SEASONS
	#if !USE_ALPHA_TEST && !defined(BLEND)
		RDZres.a = inColor.a;
	#endif
	
	if(color.g * 2.0 > color.b + color.r){
if(color.a != 0.){
RDZres.rgb *= normalize(inColor.rgb);}}
if(color.a == 0.0){
RDZres.rgb *= inColor.rgb;
}
	#ifdef AO
RDZres.rgb *= normalize(inColor.rgb);
#endif
#else
	vec2 uv = inColor.xy;
	RDZres.rgb *= mix(vec3(1.0,1.0,1.0), texture2D( TEXTURE_2, uv).rgb*2.0, inColor.b);
	RDZres.rgb *= inColor.aaa;
	RDZres.a = 1.0;
#endif

	RDZres.rgb = ACESFilm(RDZres.rgb);
	RDZres.rgb *= vec3(0.95,0.8,0.68);

	RDZres.rgb += vec3(-0.39,-0.39,-0.27)*hujand;

#ifndef ALPHA_TEST
	float ert = mix(0.0,smoothstep(0.2, 1.6,length(sin(atan(wpos.x/wpos.z) * 4.0)))*10.4,clamp(length(wpos.xz)/32.0,0.0,1.0));

RDZres.rgb += vec3(0.3,0.3,0.4)*pow(uv1.x*1.2,1.0)*hujand*malamd;

float betcheck = smoothstep(
				0.5,
				0.75,
				noise(p.xz));

if(uv1.y>.85){
if((dirlek.y > 0.5)){
	RDZres.rgb = mix(RDZres.rgb,vec3(0.25),clamp(length(-wpos)/RENDER_DISTANCE*19.2,0.0,0.6)*
			betcheck*
			hujand
			);
	RDZres.rgb += 
			ert*
			vec3(0.08)*
			betcheck*
			hujand;
RDZres.rgb += betcheck*vec3(-0.04)*hujand;
}}

if(!(uv1.y < 0.878)){
if(abs(dirlek.z) > 0.5){
	RDZres.rgb *= 
			bscshdG.rgb*0.46;}}
if(abs(dirlek.y) > 0.5){
	RDZres.rgb *= 
			vec3(0.9);}
#endif
if((dirlek.y > 0.5)){
RDZres.rgb += vec3(-0.1)*sorepagid;}

	float sedot = mix(
	   0.5,
	   1.0,
		   smoothstep(
			 0.865,
			 0.873,
			 uv1.y));

	   RDZres.rgb *= mix(sedot,1.0,uv1.x);

#ifndef ALPHA_TEST
#ifndef SEASONS
#if defined (BLEND) || defined (FOG)
  	if(color.b > color.r){

	RDZres.rgb *=
  vec3(0.0);
	RDZres.rgb +=
  vec3(0.07,0.07,0.15)*malamd;
	RDZres.rgb += 
  vec3(0.13,.3,0.57)*siangd;

// vec3(000000001);


	float ww;
	vec3 x = position;

for(int l = 0;l<watloop;l++){
ww += wave(x.xz*0.43);
x *= 2.0;}

RDZres.rgb += ww*vec3(0.13,0.13,0.13)*0.589*fresnel;

vec3 ref = clamp(1.0-length(-wpos.z*10.0)/RENDER_DISTANCE*3.0,0.0,5.0)*vec3(0.64,0.52,0.47)*length(-wpos.x)/RENDER_DISTANCE*3.0*sorepagid;

	RDZres.rgb += ref*
		ww;

		RDZres.rgb +=  pow(uv1.x*0.8,4.8)*vec3(0.6,0.3,-0.5)*malamd;

RDZres.rgb *= mix(sedot,1.0,uv1.x);

RDZres.rgb = mix(
		RDZres.rgb,
		FOG_COLOR.rgb*1.1,
clamp(length(-wpos)/RENDER_DISTANCE*1.42,0.15,1.0));

RDZres.rgb += vec3(
	-0.223,
	-0.224,
	-0.226)*
goa;
}
#endif
#endif
#endif

  	if(color.b > color.r){
}else{
RDZres.rgb = mix(
	RDZres.rgb, 
	FOG_COLOR.rgb*
	vec3(0.76,0.6,0.5),
clamp(length(-wpos)/RENDER_DISTANCE*0.5589,0.15,0.65));

//vec3(0.76,0.6,0.5)
}

RDZres.rgb = mix(RDZres.rgb,FOG_COLOR.rgb*0.7, clamp(length(-wpos)/RENDER_DISTANCE*4.87,0.15,1.0)*hujand);

RDZres.rgb = mix(
	RDZres.rgb,
	vec3(0.4,0.6,0.8),
clamp(length(-wpos)/RENDER_DISTANCE*0.7589,0.15,0.65)*sorepagid);

if(FOG_CONTROL.x == 0.0 && FOG_COLOR.b > FOG_COLOR.r){
  	if(color.b > color.r){
RDZres.rgb = mix(
	RDZres.rgb,
	vec3(0.3,0.3,0.3),
clamp(length(-wpos)/RENDER_DISTANCE*0.9589,0.15,0.65));
}}

if(FOG_CONTROL.x == 0.0 && FOG_COLOR.b > FOG_COLOR.r){
  	if(color.b > color.r){
}else{
#ifndef ALPHA_TEST
	highp float shapemove = sin(
		noise(vec2(causticmove)));
	RDZres.rgb *=
		clamp(pow(abs(shapemove)/1.0, 0.7), 0.6, 1.0);
  #endif
           }
	RDZres.rgb *= vec3(0.56,0.9,0.7);
	RDZres.rgb = mix(
		RDZres.rgb,
		FOG_COLOR.rgb*
		vec3(
			0.2,
			0.57,
			0.5),
clamp(length(-wpos)/RENDER_DISTANCE*5.0,0.0,1.0));
	vec3 warna = 1.-exp(-pow(1./length(vec2(0.95) - uv1.x*0.93)*0.4, 1.1)*vec3(0.0, 0.4, 0.5)*0.3);
	RDZres.rgb += warna*
		uv1.x;
	}
  	else{
	vec3 warna = 1.-exp(-pow(1./length(vec2(0.95) - uv1.x*0.93)*0.4, 1.1)*vec3(0.7,0.1,-0.5)*0.36);
	RDZres.rgb += warna*
	uv1.x*
	malamd;
		RDZres.rgb +=  pow(uv1.x*0.8,4.8)*vec3(0.6,0.3,-0.5)*malamd;}
		

//      :) Keep Smile! (:       \\

#ifdef FOG
	RDZres.rgb = mix( RDZres.rgb, fogColor.rgb, fogColor.a );
#endif

//~ Redezerd

	gl_FragColor = RDZres;
	
#endif // BYPASS_PIXEL_SHADER
}
